__author__ = 'gg'

import os
import smtplib
from email.message import EmailMessage
from libraries.exceptions.auraexceptions import MailingException


class AuraMailer():
    config = None

    def __init__(self, config):
        self.config = config
        self.admin_mails = config.get("admin_mail")


    def send_admin_mail(self, subject, body):
        admin_mails = self.admin_mails.split()

        for mail_to in admin_mails:
            self.__send(mail_to, subject, body)

    def __send(self, mail_to, subject, body):
        mail_server = self.config.get("mail_server")
        mail_port = self.config.get("mail_server_port")
        mail_user = self.config.get("mail_user")
        mail_pass = self.config.get("mail_pass")
        from_mail = self.config.get("from_mail")

        if mail_server == "":
            raise MailingException("Mail Server not set")
        if mail_port == "":
            raise MailingException("Mailserver Port not set")
        if mail_user == "":
            raise MailingException("Mail user not set")
        if mail_pass == "":
            raise MailingException("No Password for mailing set")
        if from_mail == "":
            raise MailingException("From Mail not set")

        msg = EmailMessage()
        msg.set_content(body)
        mail_prefix = self.config.get("mail_prefix")
        if mail_prefix == "":
            msg["Subject"] = subject
        else:
            msg["Subject"] = mail_prefix + " " + subject
        msg["From"] = from_mail
        msg["To"] = mail_to

        server = smtplib.SMTP(mail_server, int(mail_port))
        server.starttls()
        server.login(mail_user, mail_pass)
        server.send_message(msg)
        server.quit()

#        sendmail_location = "/usr/sbin/sendmail"
#        p = os.popen("%s -t" % sendmail_location, "w")
#        p.write("From: %s\n" % self.from_mail)
#        p.write("To: %s\n" % mail_to)
#        p.write("Subject: " + subject + "\n")
#        p.write("\n") # blank line separating headers from body
#        p.write(body)
#        status = p.close()
#        return status
