#!/usr/bin/python3

from libraries.database.broadcasts import *
import simplejson
import logging
import sqlalchemy

from modules.communication.liquidsoap.communicator import LiquidSoapCommunicator
from modules.monitoring.diskspace_watcher import DiskSpaceWatcher
from libraries.base.config import AuraConfig

def alchemyencoder(obj):
    """JSON encoder function for SQLAlchemy special classes."""
    if isinstance(obj, datetime.date):
        return obj.isoformat()
    elif isinstance(obj, decimal.Decimal):
        return float(obj)
    elif isinstance(obj, sqlalchemy.orm.state.InstanceState):
        return ""
    #elif isinstance(obj, Schedule):
    #    return simplejson.dumps([obj._asdict()], default=alchemyencoder)
    else:
        return str(obj)

def select_with_relationship():
    se = TrackServiceScheduleEntry.select_all()
    for e in se:
        print(e._asdict())

#    programme_as_string = simplejson.dumps([se[0]._asdict()], default=alchemyencoder)
#    print(programme_as_string)

def start_diskspace_watcher():
    config = AuraConfig()
    config.read_config()
    diskspace_watcher = DiskSpaceWatcher(config.config, logging.getLogger("AuraEngine"), LiquidSoapCommunicator(config.config))
    diskspace_watcher.run()

# # ## ## ## ## ## # #
# # ENTRY FUNCTION # #
# # ## ## ## ## ## # #
def main():
    #select_with_relationship()
    start_diskspace_watcher()
# # ## ## ## ## ## ## # #
# # End ENTRY FUNCTION # #
# # ## ## ## ## ## ## # #


if __name__ == "__main__":
    main()

